//
// Created by philipp on 12.02.18.
//

#ifndef CAR_PLATOONCONTROLLER_H
#define CAR_PLATOONCONTROLLER_H

#include <functional>

// #include "PlatoonProtocolLib/Vehicle.h"
#include "C2CBase.h"
#include "PlatoonProtocolLib/Protocol.h"
#include "PC2CarLib/CommandReceiver.h"
#include "EgoMotion.h"
#include "PlatoonState.h"

namespace car
{

class PlatoonController
{
public:
    using Callback = std::function<void()>;
    
    PlatoonController(C2CBase& c2c,
                      pc2car::CommandReceiver::Ptr pc,
                      EgoMotion& egoMotion);
      
    void run();
    
    Callback cruiseControllerNotify;

private:

    C2CBase& c2c;
    pc2car::CommandReceiver::Ptr pc;
    EgoMotion& egoMotion;
    
    // TODO check these values!
    PlatoonState curState = PlatoonState::CACC_FV;

    bool wantsPlatoon = false;

    // TODO check these values!
    float desSpeed = 0.0;

    // METHODS

    void run_ACC();
    void run_CACC_FV();
    void run_CACC_LV();
    
};

}

#endif //CAR_PLATOONCONTROLLER_H
